<?php

namespace ArtabanMarketplace\Model\Base;

use \DateTime;
use \Exception;
use \PDO;
use ArtabanMarketplace\Model\AmpSeller as ChildAmpSeller;
use ArtabanMarketplace\Model\AmpSellerQuery as ChildAmpSellerQuery;
use ArtabanMarketplace\Model\AmpSellerVersionQuery as ChildAmpSellerVersionQuery;
use ArtabanMarketplace\Model\Map\AmpSellerVersionTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;
use Propel\Runtime\Util\PropelDateTime;

abstract class AmpSellerVersion implements ActiveRecordInterface
{
    /**
     * TableMap class name
     */
    const TABLE_MAP = '\\ArtabanMarketplace\\Model\\Map\\AmpSellerVersionTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var boolean
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var boolean
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = array();

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = array();

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the ref field.
     * @var        string
     */
    protected $ref;

    /**
     * The value for the visible field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $visible;

    /**
     * The value for the address1 field.
     * @var        string
     */
    protected $address1;

    /**
     * The value for the address2 field.
     * @var        string
     */
    protected $address2;

    /**
     * The value for the address3 field.
     * @var        string
     */
    protected $address3;

    /**
     * The value for the zipcode field.
     * @var        string
     */
    protected $zipcode;

    /**
     * The value for the city field.
     * @var        string
     */
    protected $city;

    /**
     * The value for the country_id field.
     * @var        int
     */
    protected $country_id;

    /**
     * The value for the email field.
     * @var        string
     */
    protected $email;

    /**
     * The value for the phone field.
     * @var        string
     */
    protected $phone;

    /**
     * The value for the fax field.
     * @var        string
     */
    protected $fax;

    /**
     * The value for the url field.
     * @var        string
     */
    protected $url;

    /**
     * The value for the facebook field.
     * @var        string
     */
    protected $facebook;

    /**
     * The value for the twitter field.
     * @var        string
     */
    protected $twitter;

    /**
     * The value for the pinterest field.
     * @var        string
     */
    protected $pinterest;

    /**
     * The value for the google field.
     * @var        string
     */
    protected $google;

    /**
     * The value for the youtube field.
     * @var        string
     */
    protected $youtube;

    /**
     * The value for the instagram field.
     * @var        string
     */
    protected $instagram;

    /**
     * The value for the latitude field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $latitude;

    /**
     * The value for the longitude field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $longitude;

    /**
     * The value for the created_at field.
     * @var        string
     */
    protected $created_at;

    /**
     * The value for the updated_at field.
     * @var        string
     */
    protected $updated_at;

    /**
     * The value for the version field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $version;

    /**
     * The value for the version_created_at field.
     * @var        string
     */
    protected $version_created_at;

    /**
     * The value for the version_created_by field.
     * @var        string
     */
    protected $version_created_by;

    /**
     * The value for the amp_seller_admin_ids field.
     * @var        array
     */
    protected $amp_seller_admin_ids;

    /**
     * The unserialized $amp_seller_admin_ids value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_admin_ids_unserialized;

    /**
     * The value for the amp_seller_admin_versions field.
     * @var        array
     */
    protected $amp_seller_admin_versions;

    /**
     * The unserialized $amp_seller_admin_versions value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_admin_versions_unserialized;

    /**
     * The value for the amp_seller_product_ids field.
     * @var        array
     */
    protected $amp_seller_product_ids;

    /**
     * The unserialized $amp_seller_product_ids value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_product_ids_unserialized;

    /**
     * The value for the amp_seller_product_versions field.
     * @var        array
     */
    protected $amp_seller_product_versions;

    /**
     * The unserialized $amp_seller_product_versions value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_product_versions_unserialized;

    /**
     * The value for the amp_seller_order_ids field.
     * @var        array
     */
    protected $amp_seller_order_ids;

    /**
     * The unserialized $amp_seller_order_ids value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_order_ids_unserialized;

    /**
     * The value for the amp_seller_order_versions field.
     * @var        array
     */
    protected $amp_seller_order_versions;

    /**
     * The unserialized $amp_seller_order_versions value - i.e. the persisted object.
     * This is necessary to avoid repeated calls to unserialize() at runtime.
     * @var object
     */
    protected $amp_seller_order_versions_unserialized;

    /**
     * @var        AmpSeller
     */
    protected $aAmpSeller;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var boolean
     */
    protected $alreadyInSave = false;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see __construct()
     */
    public function applyDefaultValues()
    {
        $this->visible = 0;
        $this->latitude = '0';
        $this->longitude = '0';
        $this->version = 0;
    }

    /**
     * Initializes internal state of ArtabanMarketplace\Model\Base\AmpSellerVersion object.
     * @see applyDefaults()
     */
    public function __construct()
    {
        $this->applyDefaultValues();
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return boolean True if the object has been modified.
     */
    public function isModified()
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param  string  $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return boolean True if $col has been modified.
     */
    public function isColumnModified($col)
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns()
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return boolean true, if the object has never been persisted.
     */
    public function isNew()
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param boolean $b the state of the object.
     */
    public function setNew($b)
    {
        $this->new = (Boolean) $b;
    }

    /**
     * Whether this object has been deleted.
     * @return boolean The deleted state of this object.
     */
    public function isDeleted()
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param  boolean $b The deleted state of this object.
     * @return void
     */
    public function setDeleted($b)
    {
        $this->deleted = (Boolean) $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param  string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified($col = null)
    {
        if (null !== $col) {
            if (isset($this->modifiedColumns[$col])) {
                unset($this->modifiedColumns[$col]);
            }
        } else {
            $this->modifiedColumns = array();
        }
    }

    /**
     * Compares this with another <code>AmpSellerVersion</code> instance.  If
     * <code>obj</code> is an instance of <code>AmpSellerVersion</code>, delegates to
     * <code>equals(AmpSellerVersion)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param  mixed   $obj The object to compare to.
     * @return boolean Whether equal to the object specified.
     */
    public function equals($obj)
    {
        $thisclazz = get_class($this);
        if (!is_object($obj) || !($obj instanceof $thisclazz)) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey()
            || null === $obj->getPrimaryKey())  {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int Hashcode
     */
    public function hashCode()
    {
        if (null !== $this->getPrimaryKey()) {
            return crc32(serialize($this->getPrimaryKey()));
        }

        return crc32(serialize(clone $this));
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns()
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param  string  $name The virtual column name
     * @return boolean
     */
    public function hasVirtualColumn($name)
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param  string $name The virtual column name
     * @return mixed
     *
     * @throws PropelException
     */
    public function getVirtualColumn($name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of inexistent virtual column %s.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name  The virtual column name
     * @param mixed  $value The value to give to the virtual column
     *
     * @return AmpSellerVersion The current object, for fluid interface
     */
    public function setVirtualColumn($name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param  string  $msg
     * @param  int     $priority One of the Propel::LOG_* logging levels
     * @return boolean
     */
    protected function log($msg, $priority = Propel::LOG_INFO)
    {
        return Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     *
     * @return AmpSellerVersion The current object, for fluid interface
     */
    public function importFrom($parser, $data)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), TableMap::TYPE_PHPNAME);

        return $this;
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param  mixed   $parser                 A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param  boolean $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @return string  The exported data
     */
    public function exportTo($parser, $includeLazyLoadColumns = true)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray(TableMap::TYPE_PHPNAME, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     */
    public function __sleep()
    {
        $this->clearAllReferences();

        return array_keys(get_object_vars($this));
    }

    /**
     * Get the [id] column value.
     *
     * @return   int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [ref] column value.
     *
     * @return   string
     */
    public function getRef()
    {

        return $this->ref;
    }

    /**
     * Get the [visible] column value.
     *
     * @return   int
     */
    public function getVisible()
    {

        return $this->visible;
    }

    /**
     * Get the [address1] column value.
     *
     * @return   string
     */
    public function getAddress1()
    {

        return $this->address1;
    }

    /**
     * Get the [address2] column value.
     *
     * @return   string
     */
    public function getAddress2()
    {

        return $this->address2;
    }

    /**
     * Get the [address3] column value.
     *
     * @return   string
     */
    public function getAddress3()
    {

        return $this->address3;
    }

    /**
     * Get the [zipcode] column value.
     *
     * @return   string
     */
    public function getZipcode()
    {

        return $this->zipcode;
    }

    /**
     * Get the [city] column value.
     *
     * @return   string
     */
    public function getCity()
    {

        return $this->city;
    }

    /**
     * Get the [country_id] column value.
     *
     * @return   int
     */
    public function getCountryId()
    {

        return $this->country_id;
    }

    /**
     * Get the [email] column value.
     *
     * @return   string
     */
    public function getEmail()
    {

        return $this->email;
    }

    /**
     * Get the [phone] column value.
     *
     * @return   string
     */
    public function getPhone()
    {

        return $this->phone;
    }

    /**
     * Get the [fax] column value.
     *
     * @return   string
     */
    public function getFax()
    {

        return $this->fax;
    }

    /**
     * Get the [url] column value.
     *
     * @return   string
     */
    public function getUrl()
    {

        return $this->url;
    }

    /**
     * Get the [facebook] column value.
     *
     * @return   string
     */
    public function getFacebook()
    {

        return $this->facebook;
    }

    /**
     * Get the [twitter] column value.
     *
     * @return   string
     */
    public function getTwitter()
    {

        return $this->twitter;
    }

    /**
     * Get the [pinterest] column value.
     *
     * @return   string
     */
    public function getPinterest()
    {

        return $this->pinterest;
    }

    /**
     * Get the [google] column value.
     *
     * @return   string
     */
    public function getGoogle()
    {

        return $this->google;
    }

    /**
     * Get the [youtube] column value.
     *
     * @return   string
     */
    public function getYoutube()
    {

        return $this->youtube;
    }

    /**
     * Get the [instagram] column value.
     *
     * @return   string
     */
    public function getInstagram()
    {

        return $this->instagram;
    }

    /**
     * Get the [latitude] column value.
     *
     * @return   string
     */
    public function getLatitude()
    {

        return $this->latitude;
    }

    /**
     * Get the [longitude] column value.
     *
     * @return   string
     */
    public function getLongitude()
    {

        return $this->longitude;
    }

    /**
     * Get the [optionally formatted] temporal [created_at] column value.
     *
     *
     * @param      string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw \DateTime object will be returned.
     *
     * @return mixed Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getCreatedAt($format = NULL)
    {
        if ($format === null) {
            return $this->created_at;
        } else {
            return $this->created_at instanceof \DateTime ? $this->created_at->format($format) : null;
        }
    }

    /**
     * Get the [optionally formatted] temporal [updated_at] column value.
     *
     *
     * @param      string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw \DateTime object will be returned.
     *
     * @return mixed Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getUpdatedAt($format = NULL)
    {
        if ($format === null) {
            return $this->updated_at;
        } else {
            return $this->updated_at instanceof \DateTime ? $this->updated_at->format($format) : null;
        }
    }

    /**
     * Get the [version] column value.
     *
     * @return   int
     */
    public function getVersion()
    {

        return $this->version;
    }

    /**
     * Get the [optionally formatted] temporal [version_created_at] column value.
     *
     *
     * @param      string $format The date/time format string (either date()-style or strftime()-style).
     *                            If format is NULL, then the raw \DateTime object will be returned.
     *
     * @return mixed Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00
     *
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getVersionCreatedAt($format = NULL)
    {
        if ($format === null) {
            return $this->version_created_at;
        } else {
            return $this->version_created_at instanceof \DateTime ? $this->version_created_at->format($format) : null;
        }
    }

    /**
     * Get the [version_created_by] column value.
     *
     * @return   string
     */
    public function getVersionCreatedBy()
    {

        return $this->version_created_by;
    }

    /**
     * Get the [amp_seller_admin_ids] column value.
     *
     * @return   array
     */
    public function getAmpSellerAdminIds()
    {
        if (null === $this->amp_seller_admin_ids_unserialized) {
            $this->amp_seller_admin_ids_unserialized = array();
        }
        if (!$this->amp_seller_admin_ids_unserialized && null !== $this->amp_seller_admin_ids) {
            $amp_seller_admin_ids_unserialized = substr($this->amp_seller_admin_ids, 2, -2);
            $this->amp_seller_admin_ids_unserialized = $amp_seller_admin_ids_unserialized ? explode(' | ', $amp_seller_admin_ids_unserialized) : array();
        }

        return $this->amp_seller_admin_ids_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_admin_ids] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerAdminId($value)
    {
        return in_array($value, $this->getAmpSellerAdminIds());
    } // hasAmpSellerAdminId()

    /**
     * Get the [amp_seller_admin_versions] column value.
     *
     * @return   array
     */
    public function getAmpSellerAdminVersions()
    {
        if (null === $this->amp_seller_admin_versions_unserialized) {
            $this->amp_seller_admin_versions_unserialized = array();
        }
        if (!$this->amp_seller_admin_versions_unserialized && null !== $this->amp_seller_admin_versions) {
            $amp_seller_admin_versions_unserialized = substr($this->amp_seller_admin_versions, 2, -2);
            $this->amp_seller_admin_versions_unserialized = $amp_seller_admin_versions_unserialized ? explode(' | ', $amp_seller_admin_versions_unserialized) : array();
        }

        return $this->amp_seller_admin_versions_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_admin_versions] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerAdminVersion($value)
    {
        return in_array($value, $this->getAmpSellerAdminVersions());
    } // hasAmpSellerAdminVersion()

    /**
     * Get the [amp_seller_product_ids] column value.
     *
     * @return   array
     */
    public function getAmpSellerProductIds()
    {
        if (null === $this->amp_seller_product_ids_unserialized) {
            $this->amp_seller_product_ids_unserialized = array();
        }
        if (!$this->amp_seller_product_ids_unserialized && null !== $this->amp_seller_product_ids) {
            $amp_seller_product_ids_unserialized = substr($this->amp_seller_product_ids, 2, -2);
            $this->amp_seller_product_ids_unserialized = $amp_seller_product_ids_unserialized ? explode(' | ', $amp_seller_product_ids_unserialized) : array();
        }

        return $this->amp_seller_product_ids_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_product_ids] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerProductId($value)
    {
        return in_array($value, $this->getAmpSellerProductIds());
    } // hasAmpSellerProductId()

    /**
     * Get the [amp_seller_product_versions] column value.
     *
     * @return   array
     */
    public function getAmpSellerProductVersions()
    {
        if (null === $this->amp_seller_product_versions_unserialized) {
            $this->amp_seller_product_versions_unserialized = array();
        }
        if (!$this->amp_seller_product_versions_unserialized && null !== $this->amp_seller_product_versions) {
            $amp_seller_product_versions_unserialized = substr($this->amp_seller_product_versions, 2, -2);
            $this->amp_seller_product_versions_unserialized = $amp_seller_product_versions_unserialized ? explode(' | ', $amp_seller_product_versions_unserialized) : array();
        }

        return $this->amp_seller_product_versions_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_product_versions] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerProductVersion($value)
    {
        return in_array($value, $this->getAmpSellerProductVersions());
    } // hasAmpSellerProductVersion()

    /**
     * Get the [amp_seller_order_ids] column value.
     *
     * @return   array
     */
    public function getAmpSellerOrderIds()
    {
        if (null === $this->amp_seller_order_ids_unserialized) {
            $this->amp_seller_order_ids_unserialized = array();
        }
        if (!$this->amp_seller_order_ids_unserialized && null !== $this->amp_seller_order_ids) {
            $amp_seller_order_ids_unserialized = substr($this->amp_seller_order_ids, 2, -2);
            $this->amp_seller_order_ids_unserialized = $amp_seller_order_ids_unserialized ? explode(' | ', $amp_seller_order_ids_unserialized) : array();
        }

        return $this->amp_seller_order_ids_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_order_ids] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerOrderId($value)
    {
        return in_array($value, $this->getAmpSellerOrderIds());
    } // hasAmpSellerOrderId()

    /**
     * Get the [amp_seller_order_versions] column value.
     *
     * @return   array
     */
    public function getAmpSellerOrderVersions()
    {
        if (null === $this->amp_seller_order_versions_unserialized) {
            $this->amp_seller_order_versions_unserialized = array();
        }
        if (!$this->amp_seller_order_versions_unserialized && null !== $this->amp_seller_order_versions) {
            $amp_seller_order_versions_unserialized = substr($this->amp_seller_order_versions, 2, -2);
            $this->amp_seller_order_versions_unserialized = $amp_seller_order_versions_unserialized ? explode(' | ', $amp_seller_order_versions_unserialized) : array();
        }

        return $this->amp_seller_order_versions_unserialized;
    }

    /**
     * Test the presence of a value in the [amp_seller_order_versions] array column value.
     * @param      mixed $value
     *
     * @return boolean
     */
    public function hasAmpSellerOrderVersion($value)
    {
        return in_array($value, $this->getAmpSellerOrderVersions());
    } // hasAmpSellerOrderVersion()

    /**
     * Set the value of [id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::ID] = true;
        }

        if ($this->aAmpSeller !== null && $this->aAmpSeller->getId() !== $v) {
            $this->aAmpSeller = null;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [ref] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setRef($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->ref !== $v) {
            $this->ref = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::REF] = true;
        }


        return $this;
    } // setRef()

    /**
     * Set the value of [visible] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setVisible($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->visible !== $v) {
            $this->visible = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::VISIBLE] = true;
        }


        return $this;
    } // setVisible()

    /**
     * Set the value of [address1] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAddress1($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->address1 !== $v) {
            $this->address1 = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::ADDRESS1] = true;
        }


        return $this;
    } // setAddress1()

    /**
     * Set the value of [address2] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAddress2($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->address2 !== $v) {
            $this->address2 = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::ADDRESS2] = true;
        }


        return $this;
    } // setAddress2()

    /**
     * Set the value of [address3] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAddress3($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->address3 !== $v) {
            $this->address3 = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::ADDRESS3] = true;
        }


        return $this;
    } // setAddress3()

    /**
     * Set the value of [zipcode] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setZipcode($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->zipcode !== $v) {
            $this->zipcode = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::ZIPCODE] = true;
        }


        return $this;
    } // setZipcode()

    /**
     * Set the value of [city] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setCity($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->city !== $v) {
            $this->city = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::CITY] = true;
        }


        return $this;
    } // setCity()

    /**
     * Set the value of [country_id] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setCountryId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->country_id !== $v) {
            $this->country_id = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::COUNTRY_ID] = true;
        }


        return $this;
    } // setCountryId()

    /**
     * Set the value of [email] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setEmail($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->email !== $v) {
            $this->email = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::EMAIL] = true;
        }


        return $this;
    } // setEmail()

    /**
     * Set the value of [phone] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setPhone($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->phone !== $v) {
            $this->phone = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::PHONE] = true;
        }


        return $this;
    } // setPhone()

    /**
     * Set the value of [fax] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setFax($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->fax !== $v) {
            $this->fax = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::FAX] = true;
        }


        return $this;
    } // setFax()

    /**
     * Set the value of [url] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setUrl($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->url !== $v) {
            $this->url = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::URL] = true;
        }


        return $this;
    } // setUrl()

    /**
     * Set the value of [facebook] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setFacebook($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->facebook !== $v) {
            $this->facebook = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::FACEBOOK] = true;
        }


        return $this;
    } // setFacebook()

    /**
     * Set the value of [twitter] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setTwitter($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->twitter !== $v) {
            $this->twitter = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::TWITTER] = true;
        }


        return $this;
    } // setTwitter()

    /**
     * Set the value of [pinterest] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setPinterest($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->pinterest !== $v) {
            $this->pinterest = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::PINTEREST] = true;
        }


        return $this;
    } // setPinterest()

    /**
     * Set the value of [google] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setGoogle($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->google !== $v) {
            $this->google = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::GOOGLE] = true;
        }


        return $this;
    } // setGoogle()

    /**
     * Set the value of [youtube] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setYoutube($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->youtube !== $v) {
            $this->youtube = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::YOUTUBE] = true;
        }


        return $this;
    } // setYoutube()

    /**
     * Set the value of [instagram] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setInstagram($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->instagram !== $v) {
            $this->instagram = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::INSTAGRAM] = true;
        }


        return $this;
    } // setInstagram()

    /**
     * Set the value of [latitude] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setLatitude($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->latitude !== $v) {
            $this->latitude = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::LATITUDE] = true;
        }


        return $this;
    } // setLatitude()

    /**
     * Set the value of [longitude] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setLongitude($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->longitude !== $v) {
            $this->longitude = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::LONGITUDE] = true;
        }


        return $this;
    } // setLongitude()

    /**
     * Sets the value of [created_at] column to a normalized version of the date/time value specified.
     *
     * @param      mixed $v string, integer (timestamp), or \DateTime value.
     *               Empty strings are treated as NULL.
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setCreatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, '\DateTime');
        if ($this->created_at !== null || $dt !== null) {
            if ($dt !== $this->created_at) {
                $this->created_at = $dt;
                $this->modifiedColumns[AmpSellerVersionTableMap::CREATED_AT] = true;
            }
        } // if either are not null


        return $this;
    } // setCreatedAt()

    /**
     * Sets the value of [updated_at] column to a normalized version of the date/time value specified.
     *
     * @param      mixed $v string, integer (timestamp), or \DateTime value.
     *               Empty strings are treated as NULL.
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setUpdatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, '\DateTime');
        if ($this->updated_at !== null || $dt !== null) {
            if ($dt !== $this->updated_at) {
                $this->updated_at = $dt;
                $this->modifiedColumns[AmpSellerVersionTableMap::UPDATED_AT] = true;
            }
        } // if either are not null


        return $this;
    } // setUpdatedAt()

    /**
     * Set the value of [version] column.
     *
     * @param      int $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setVersion($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->version !== $v) {
            $this->version = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::VERSION] = true;
        }


        return $this;
    } // setVersion()

    /**
     * Sets the value of [version_created_at] column to a normalized version of the date/time value specified.
     *
     * @param      mixed $v string, integer (timestamp), or \DateTime value.
     *               Empty strings are treated as NULL.
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setVersionCreatedAt($v)
    {
        $dt = PropelDateTime::newInstance($v, null, '\DateTime');
        if ($this->version_created_at !== null || $dt !== null) {
            if ($dt !== $this->version_created_at) {
                $this->version_created_at = $dt;
                $this->modifiedColumns[AmpSellerVersionTableMap::VERSION_CREATED_AT] = true;
            }
        } // if either are not null


        return $this;
    } // setVersionCreatedAt()

    /**
     * Set the value of [version_created_by] column.
     *
     * @param      string $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setVersionCreatedBy($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->version_created_by !== $v) {
            $this->version_created_by = $v;
            $this->modifiedColumns[AmpSellerVersionTableMap::VERSION_CREATED_BY] = true;
        }


        return $this;
    } // setVersionCreatedBy()

    /**
     * Set the value of [amp_seller_admin_ids] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAmpSellerAdminIds($v)
    {
        if ($this->amp_seller_admin_ids_unserialized !== $v) {
            $this->amp_seller_admin_ids_unserialized = $v;
            $this->amp_seller_admin_ids = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS] = true;
        }


        return $this;
    } // setAmpSellerAdminIds()

    /**
     * Adds a value to the [amp_seller_admin_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function addAmpSellerAdminId($value)
    {
        $currentArray = $this->getAmpSellerAdminIds();
        $currentArray []= $value;
        $this->setAmpSellerAdminIds($currentArray);

        return $this;
    } // addAmpSellerAdminId()

    /**
     * Removes a value from the [amp_seller_admin_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function removeAmpSellerAdminId($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerAdminIds() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerAdminIds($targetArray);

        return $this;
    } // removeAmpSellerAdminId()

    /**
     * Set the value of [amp_seller_admin_versions] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAmpSellerAdminVersions($v)
    {
        if ($this->amp_seller_admin_versions_unserialized !== $v) {
            $this->amp_seller_admin_versions_unserialized = $v;
            $this->amp_seller_admin_versions = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS] = true;
        }


        return $this;
    } // setAmpSellerAdminVersions()

    /**
     * Adds a value to the [amp_seller_admin_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function addAmpSellerAdminVersion($value)
    {
        $currentArray = $this->getAmpSellerAdminVersions();
        $currentArray []= $value;
        $this->setAmpSellerAdminVersions($currentArray);

        return $this;
    } // addAmpSellerAdminVersion()

    /**
     * Removes a value from the [amp_seller_admin_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function removeAmpSellerAdminVersion($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerAdminVersions() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerAdminVersions($targetArray);

        return $this;
    } // removeAmpSellerAdminVersion()

    /**
     * Set the value of [amp_seller_product_ids] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAmpSellerProductIds($v)
    {
        if ($this->amp_seller_product_ids_unserialized !== $v) {
            $this->amp_seller_product_ids_unserialized = $v;
            $this->amp_seller_product_ids = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS] = true;
        }


        return $this;
    } // setAmpSellerProductIds()

    /**
     * Adds a value to the [amp_seller_product_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function addAmpSellerProductId($value)
    {
        $currentArray = $this->getAmpSellerProductIds();
        $currentArray []= $value;
        $this->setAmpSellerProductIds($currentArray);

        return $this;
    } // addAmpSellerProductId()

    /**
     * Removes a value from the [amp_seller_product_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function removeAmpSellerProductId($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerProductIds() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerProductIds($targetArray);

        return $this;
    } // removeAmpSellerProductId()

    /**
     * Set the value of [amp_seller_product_versions] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAmpSellerProductVersions($v)
    {
        if ($this->amp_seller_product_versions_unserialized !== $v) {
            $this->amp_seller_product_versions_unserialized = $v;
            $this->amp_seller_product_versions = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS] = true;
        }


        return $this;
    } // setAmpSellerProductVersions()

    /**
     * Adds a value to the [amp_seller_product_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function addAmpSellerProductVersion($value)
    {
        $currentArray = $this->getAmpSellerProductVersions();
        $currentArray []= $value;
        $this->setAmpSellerProductVersions($currentArray);

        return $this;
    } // addAmpSellerProductVersion()

    /**
     * Removes a value from the [amp_seller_product_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function removeAmpSellerProductVersion($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerProductVersions() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerProductVersions($targetArray);

        return $this;
    } // removeAmpSellerProductVersion()

    /**
     * Set the value of [amp_seller_order_ids] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAmpSellerOrderIds($v)
    {
        if ($this->amp_seller_order_ids_unserialized !== $v) {
            $this->amp_seller_order_ids_unserialized = $v;
            $this->amp_seller_order_ids = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS] = true;
        }


        return $this;
    } // setAmpSellerOrderIds()

    /**
     * Adds a value to the [amp_seller_order_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function addAmpSellerOrderId($value)
    {
        $currentArray = $this->getAmpSellerOrderIds();
        $currentArray []= $value;
        $this->setAmpSellerOrderIds($currentArray);

        return $this;
    } // addAmpSellerOrderId()

    /**
     * Removes a value from the [amp_seller_order_ids] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function removeAmpSellerOrderId($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerOrderIds() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerOrderIds($targetArray);

        return $this;
    } // removeAmpSellerOrderId()

    /**
     * Set the value of [amp_seller_order_versions] column.
     *
     * @param      array $v new value
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function setAmpSellerOrderVersions($v)
    {
        if ($this->amp_seller_order_versions_unserialized !== $v) {
            $this->amp_seller_order_versions_unserialized = $v;
            $this->amp_seller_order_versions = '| ' . implode(' | ', $v) . ' |';
            $this->modifiedColumns[AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS] = true;
        }


        return $this;
    } // setAmpSellerOrderVersions()

    /**
     * Adds a value to the [amp_seller_order_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function addAmpSellerOrderVersion($value)
    {
        $currentArray = $this->getAmpSellerOrderVersions();
        $currentArray []= $value;
        $this->setAmpSellerOrderVersions($currentArray);

        return $this;
    } // addAmpSellerOrderVersion()

    /**
     * Removes a value from the [amp_seller_order_versions] array column value.
     * @param      mixed $value
     *
     * @return   \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     */
    public function removeAmpSellerOrderVersion($value)
    {
        $targetArray = array();
        foreach ($this->getAmpSellerOrderVersions() as $element) {
            if ($element != $value) {
                $targetArray []= $element;
            }
        }
        $this->setAmpSellerOrderVersions($targetArray);

        return $this;
    } // removeAmpSellerOrderVersion()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->visible !== 0) {
                return false;
            }

            if ($this->latitude !== '0') {
                return false;
            }

            if ($this->longitude !== '0') {
                return false;
            }

            if ($this->version !== 0) {
                return false;
            }

        // otherwise, everything was equal, so return TRUE
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array   $row       The row returned by DataFetcher->fetch().
     * @param int     $startcol  0-based offset column which indicates which restultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @param string  $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false, $indexType = TableMap::TYPE_NUM)
    {
        try {


            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : AmpSellerVersionTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : AmpSellerVersionTableMap::translateFieldName('Ref', TableMap::TYPE_PHPNAME, $indexType)];
            $this->ref = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : AmpSellerVersionTableMap::translateFieldName('Visible', TableMap::TYPE_PHPNAME, $indexType)];
            $this->visible = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : AmpSellerVersionTableMap::translateFieldName('Address1', TableMap::TYPE_PHPNAME, $indexType)];
            $this->address1 = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : AmpSellerVersionTableMap::translateFieldName('Address2', TableMap::TYPE_PHPNAME, $indexType)];
            $this->address2 = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 5 + $startcol : AmpSellerVersionTableMap::translateFieldName('Address3', TableMap::TYPE_PHPNAME, $indexType)];
            $this->address3 = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 6 + $startcol : AmpSellerVersionTableMap::translateFieldName('Zipcode', TableMap::TYPE_PHPNAME, $indexType)];
            $this->zipcode = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 7 + $startcol : AmpSellerVersionTableMap::translateFieldName('City', TableMap::TYPE_PHPNAME, $indexType)];
            $this->city = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 8 + $startcol : AmpSellerVersionTableMap::translateFieldName('CountryId', TableMap::TYPE_PHPNAME, $indexType)];
            $this->country_id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 9 + $startcol : AmpSellerVersionTableMap::translateFieldName('Email', TableMap::TYPE_PHPNAME, $indexType)];
            $this->email = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 10 + $startcol : AmpSellerVersionTableMap::translateFieldName('Phone', TableMap::TYPE_PHPNAME, $indexType)];
            $this->phone = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 11 + $startcol : AmpSellerVersionTableMap::translateFieldName('Fax', TableMap::TYPE_PHPNAME, $indexType)];
            $this->fax = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 12 + $startcol : AmpSellerVersionTableMap::translateFieldName('Url', TableMap::TYPE_PHPNAME, $indexType)];
            $this->url = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 13 + $startcol : AmpSellerVersionTableMap::translateFieldName('Facebook', TableMap::TYPE_PHPNAME, $indexType)];
            $this->facebook = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 14 + $startcol : AmpSellerVersionTableMap::translateFieldName('Twitter', TableMap::TYPE_PHPNAME, $indexType)];
            $this->twitter = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 15 + $startcol : AmpSellerVersionTableMap::translateFieldName('Pinterest', TableMap::TYPE_PHPNAME, $indexType)];
            $this->pinterest = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 16 + $startcol : AmpSellerVersionTableMap::translateFieldName('Google', TableMap::TYPE_PHPNAME, $indexType)];
            $this->google = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 17 + $startcol : AmpSellerVersionTableMap::translateFieldName('Youtube', TableMap::TYPE_PHPNAME, $indexType)];
            $this->youtube = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 18 + $startcol : AmpSellerVersionTableMap::translateFieldName('Instagram', TableMap::TYPE_PHPNAME, $indexType)];
            $this->instagram = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 19 + $startcol : AmpSellerVersionTableMap::translateFieldName('Latitude', TableMap::TYPE_PHPNAME, $indexType)];
            $this->latitude = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 20 + $startcol : AmpSellerVersionTableMap::translateFieldName('Longitude', TableMap::TYPE_PHPNAME, $indexType)];
            $this->longitude = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 21 + $startcol : AmpSellerVersionTableMap::translateFieldName('CreatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->created_at = (null !== $col) ? PropelDateTime::newInstance($col, null, '\DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 22 + $startcol : AmpSellerVersionTableMap::translateFieldName('UpdatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->updated_at = (null !== $col) ? PropelDateTime::newInstance($col, null, '\DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 23 + $startcol : AmpSellerVersionTableMap::translateFieldName('Version', TableMap::TYPE_PHPNAME, $indexType)];
            $this->version = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 24 + $startcol : AmpSellerVersionTableMap::translateFieldName('VersionCreatedAt', TableMap::TYPE_PHPNAME, $indexType)];
            if ($col === '0000-00-00 00:00:00') {
                $col = null;
            }
            $this->version_created_at = (null !== $col) ? PropelDateTime::newInstance($col, null, '\DateTime') : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 25 + $startcol : AmpSellerVersionTableMap::translateFieldName('VersionCreatedBy', TableMap::TYPE_PHPNAME, $indexType)];
            $this->version_created_by = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 26 + $startcol : AmpSellerVersionTableMap::translateFieldName('AmpSellerAdminIds', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_admin_ids = $col;
            $this->amp_seller_admin_ids_unserialized = null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 27 + $startcol : AmpSellerVersionTableMap::translateFieldName('AmpSellerAdminVersions', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_admin_versions = $col;
            $this->amp_seller_admin_versions_unserialized = null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 28 + $startcol : AmpSellerVersionTableMap::translateFieldName('AmpSellerProductIds', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_product_ids = $col;
            $this->amp_seller_product_ids_unserialized = null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 29 + $startcol : AmpSellerVersionTableMap::translateFieldName('AmpSellerProductVersions', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_product_versions = $col;
            $this->amp_seller_product_versions_unserialized = null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 30 + $startcol : AmpSellerVersionTableMap::translateFieldName('AmpSellerOrderIds', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_order_ids = $col;
            $this->amp_seller_order_ids_unserialized = null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 31 + $startcol : AmpSellerVersionTableMap::translateFieldName('AmpSellerOrderVersions', TableMap::TYPE_PHPNAME, $indexType)];
            $this->amp_seller_order_versions = $col;
            $this->amp_seller_order_versions_unserialized = null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 32; // 32 = AmpSellerVersionTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating \ArtabanMarketplace\Model\AmpSellerVersion object", 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {
        if ($this->aAmpSeller !== null && $this->id !== $this->aAmpSeller->getId()) {
            $this->aAmpSeller = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param      boolean $deep (optional) Whether to also de-associated any related objects.
     * @param      ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(AmpSellerVersionTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildAmpSellerVersionQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aAmpSeller = null;
        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param      ConnectionInterface $con
     * @return void
     * @throws PropelException
     * @see AmpSellerVersion::setDeleted()
     * @see AmpSellerVersion::isDeleted()
     */
    public function delete(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerVersionTableMap::DATABASE_NAME);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = ChildAmpSellerVersionQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see doSave()
     */
    public function save(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(AmpSellerVersionTableMap::DATABASE_NAME);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                AmpSellerVersionTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aAmpSeller !== null) {
                if ($this->aAmpSeller->isModified() || $this->aAmpSeller->isNew()) {
                    $affectedRows += $this->aAmpSeller->save($con);
                }
                $this->setAmpSeller($this->aAmpSeller);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @throws PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con)
    {
        $modifiedColumns = array();
        $index = 0;


         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(AmpSellerVersionTableMap::ID)) {
            $modifiedColumns[':p' . $index++]  = 'ID';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::REF)) {
            $modifiedColumns[':p' . $index++]  = 'REF';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::VISIBLE)) {
            $modifiedColumns[':p' . $index++]  = 'VISIBLE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::ADDRESS1)) {
            $modifiedColumns[':p' . $index++]  = 'ADDRESS1';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::ADDRESS2)) {
            $modifiedColumns[':p' . $index++]  = 'ADDRESS2';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::ADDRESS3)) {
            $modifiedColumns[':p' . $index++]  = 'ADDRESS3';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::ZIPCODE)) {
            $modifiedColumns[':p' . $index++]  = 'ZIPCODE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::CITY)) {
            $modifiedColumns[':p' . $index++]  = 'CITY';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::COUNTRY_ID)) {
            $modifiedColumns[':p' . $index++]  = 'COUNTRY_ID';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::EMAIL)) {
            $modifiedColumns[':p' . $index++]  = 'EMAIL';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::PHONE)) {
            $modifiedColumns[':p' . $index++]  = 'PHONE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::FAX)) {
            $modifiedColumns[':p' . $index++]  = 'FAX';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::URL)) {
            $modifiedColumns[':p' . $index++]  = 'URL';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::FACEBOOK)) {
            $modifiedColumns[':p' . $index++]  = 'FACEBOOK';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::TWITTER)) {
            $modifiedColumns[':p' . $index++]  = 'TWITTER';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::PINTEREST)) {
            $modifiedColumns[':p' . $index++]  = 'PINTEREST';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::GOOGLE)) {
            $modifiedColumns[':p' . $index++]  = 'GOOGLE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::YOUTUBE)) {
            $modifiedColumns[':p' . $index++]  = 'YOUTUBE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::INSTAGRAM)) {
            $modifiedColumns[':p' . $index++]  = 'INSTAGRAM';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::LATITUDE)) {
            $modifiedColumns[':p' . $index++]  = 'LATITUDE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::LONGITUDE)) {
            $modifiedColumns[':p' . $index++]  = 'LONGITUDE';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::CREATED_AT)) {
            $modifiedColumns[':p' . $index++]  = 'CREATED_AT';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::UPDATED_AT)) {
            $modifiedColumns[':p' . $index++]  = 'UPDATED_AT';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::VERSION)) {
            $modifiedColumns[':p' . $index++]  = 'VERSION';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::VERSION_CREATED_AT)) {
            $modifiedColumns[':p' . $index++]  = 'VERSION_CREATED_AT';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::VERSION_CREATED_BY)) {
            $modifiedColumns[':p' . $index++]  = 'VERSION_CREATED_BY';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ADMIN_IDS';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ADMIN_VERSIONS';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_PRODUCT_IDS';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_PRODUCT_VERSIONS';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ORDER_IDS';
        }
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS)) {
            $modifiedColumns[':p' . $index++]  = 'AMP_SELLER_ORDER_VERSIONS';
        }

        $sql = sprintf(
            'INSERT INTO amp_seller_version (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case 'ID':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case 'REF':
                        $stmt->bindValue($identifier, $this->ref, PDO::PARAM_STR);
                        break;
                    case 'VISIBLE':
                        $stmt->bindValue($identifier, $this->visible, PDO::PARAM_INT);
                        break;
                    case 'ADDRESS1':
                        $stmt->bindValue($identifier, $this->address1, PDO::PARAM_STR);
                        break;
                    case 'ADDRESS2':
                        $stmt->bindValue($identifier, $this->address2, PDO::PARAM_STR);
                        break;
                    case 'ADDRESS3':
                        $stmt->bindValue($identifier, $this->address3, PDO::PARAM_STR);
                        break;
                    case 'ZIPCODE':
                        $stmt->bindValue($identifier, $this->zipcode, PDO::PARAM_STR);
                        break;
                    case 'CITY':
                        $stmt->bindValue($identifier, $this->city, PDO::PARAM_STR);
                        break;
                    case 'COUNTRY_ID':
                        $stmt->bindValue($identifier, $this->country_id, PDO::PARAM_INT);
                        break;
                    case 'EMAIL':
                        $stmt->bindValue($identifier, $this->email, PDO::PARAM_STR);
                        break;
                    case 'PHONE':
                        $stmt->bindValue($identifier, $this->phone, PDO::PARAM_STR);
                        break;
                    case 'FAX':
                        $stmt->bindValue($identifier, $this->fax, PDO::PARAM_STR);
                        break;
                    case 'URL':
                        $stmt->bindValue($identifier, $this->url, PDO::PARAM_STR);
                        break;
                    case 'FACEBOOK':
                        $stmt->bindValue($identifier, $this->facebook, PDO::PARAM_STR);
                        break;
                    case 'TWITTER':
                        $stmt->bindValue($identifier, $this->twitter, PDO::PARAM_STR);
                        break;
                    case 'PINTEREST':
                        $stmt->bindValue($identifier, $this->pinterest, PDO::PARAM_STR);
                        break;
                    case 'GOOGLE':
                        $stmt->bindValue($identifier, $this->google, PDO::PARAM_STR);
                        break;
                    case 'YOUTUBE':
                        $stmt->bindValue($identifier, $this->youtube, PDO::PARAM_STR);
                        break;
                    case 'INSTAGRAM':
                        $stmt->bindValue($identifier, $this->instagram, PDO::PARAM_STR);
                        break;
                    case 'LATITUDE':
                        $stmt->bindValue($identifier, $this->latitude, PDO::PARAM_STR);
                        break;
                    case 'LONGITUDE':
                        $stmt->bindValue($identifier, $this->longitude, PDO::PARAM_STR);
                        break;
                    case 'CREATED_AT':
                        $stmt->bindValue($identifier, $this->created_at ? $this->created_at->format("Y-m-d H:i:s") : null, PDO::PARAM_STR);
                        break;
                    case 'UPDATED_AT':
                        $stmt->bindValue($identifier, $this->updated_at ? $this->updated_at->format("Y-m-d H:i:s") : null, PDO::PARAM_STR);
                        break;
                    case 'VERSION':
                        $stmt->bindValue($identifier, $this->version, PDO::PARAM_INT);
                        break;
                    case 'VERSION_CREATED_AT':
                        $stmt->bindValue($identifier, $this->version_created_at ? $this->version_created_at->format("Y-m-d H:i:s") : null, PDO::PARAM_STR);
                        break;
                    case 'VERSION_CREATED_BY':
                        $stmt->bindValue($identifier, $this->version_created_by, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_ADMIN_IDS':
                        $stmt->bindValue($identifier, $this->amp_seller_admin_ids, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_ADMIN_VERSIONS':
                        $stmt->bindValue($identifier, $this->amp_seller_admin_versions, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_PRODUCT_IDS':
                        $stmt->bindValue($identifier, $this->amp_seller_product_ids, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_PRODUCT_VERSIONS':
                        $stmt->bindValue($identifier, $this->amp_seller_product_versions, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_ORDER_IDS':
                        $stmt->bindValue($identifier, $this->amp_seller_order_ids, PDO::PARAM_STR);
                        break;
                    case 'AMP_SELLER_ORDER_VERSIONS':
                        $stmt->bindValue($identifier, $this->amp_seller_order_versions, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @return Integer Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param      string $name name
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName($name, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = AmpSellerVersionTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getRef();
                break;
            case 2:
                return $this->getVisible();
                break;
            case 3:
                return $this->getAddress1();
                break;
            case 4:
                return $this->getAddress2();
                break;
            case 5:
                return $this->getAddress3();
                break;
            case 6:
                return $this->getZipcode();
                break;
            case 7:
                return $this->getCity();
                break;
            case 8:
                return $this->getCountryId();
                break;
            case 9:
                return $this->getEmail();
                break;
            case 10:
                return $this->getPhone();
                break;
            case 11:
                return $this->getFax();
                break;
            case 12:
                return $this->getUrl();
                break;
            case 13:
                return $this->getFacebook();
                break;
            case 14:
                return $this->getTwitter();
                break;
            case 15:
                return $this->getPinterest();
                break;
            case 16:
                return $this->getGoogle();
                break;
            case 17:
                return $this->getYoutube();
                break;
            case 18:
                return $this->getInstagram();
                break;
            case 19:
                return $this->getLatitude();
                break;
            case 20:
                return $this->getLongitude();
                break;
            case 21:
                return $this->getCreatedAt();
                break;
            case 22:
                return $this->getUpdatedAt();
                break;
            case 23:
                return $this->getVersion();
                break;
            case 24:
                return $this->getVersionCreatedAt();
                break;
            case 25:
                return $this->getVersionCreatedBy();
                break;
            case 26:
                return $this->getAmpSellerAdminIds();
                break;
            case 27:
                return $this->getAmpSellerAdminVersions();
                break;
            case 28:
                return $this->getAmpSellerProductIds();
                break;
            case 29:
                return $this->getAmpSellerProductVersions();
                break;
            case 30:
                return $this->getAmpSellerOrderIds();
                break;
            case 31:
                return $this->getAmpSellerOrderVersions();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = TableMap::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['AmpSellerVersion'][serialize($this->getPrimaryKey())])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['AmpSellerVersion'][serialize($this->getPrimaryKey())] = true;
        $keys = AmpSellerVersionTableMap::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getRef(),
            $keys[2] => $this->getVisible(),
            $keys[3] => $this->getAddress1(),
            $keys[4] => $this->getAddress2(),
            $keys[5] => $this->getAddress3(),
            $keys[6] => $this->getZipcode(),
            $keys[7] => $this->getCity(),
            $keys[8] => $this->getCountryId(),
            $keys[9] => $this->getEmail(),
            $keys[10] => $this->getPhone(),
            $keys[11] => $this->getFax(),
            $keys[12] => $this->getUrl(),
            $keys[13] => $this->getFacebook(),
            $keys[14] => $this->getTwitter(),
            $keys[15] => $this->getPinterest(),
            $keys[16] => $this->getGoogle(),
            $keys[17] => $this->getYoutube(),
            $keys[18] => $this->getInstagram(),
            $keys[19] => $this->getLatitude(),
            $keys[20] => $this->getLongitude(),
            $keys[21] => $this->getCreatedAt(),
            $keys[22] => $this->getUpdatedAt(),
            $keys[23] => $this->getVersion(),
            $keys[24] => $this->getVersionCreatedAt(),
            $keys[25] => $this->getVersionCreatedBy(),
            $keys[26] => $this->getAmpSellerAdminIds(),
            $keys[27] => $this->getAmpSellerAdminVersions(),
            $keys[28] => $this->getAmpSellerProductIds(),
            $keys[29] => $this->getAmpSellerProductVersions(),
            $keys[30] => $this->getAmpSellerOrderIds(),
            $keys[31] => $this->getAmpSellerOrderVersions(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aAmpSeller) {
                $result['AmpSeller'] = $this->aAmpSeller->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param      string $name
     * @param      mixed  $value field value
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return void
     */
    public function setByName($name, $value, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = AmpSellerVersionTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        return $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @param      mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setRef($value);
                break;
            case 2:
                $this->setVisible($value);
                break;
            case 3:
                $this->setAddress1($value);
                break;
            case 4:
                $this->setAddress2($value);
                break;
            case 5:
                $this->setAddress3($value);
                break;
            case 6:
                $this->setZipcode($value);
                break;
            case 7:
                $this->setCity($value);
                break;
            case 8:
                $this->setCountryId($value);
                break;
            case 9:
                $this->setEmail($value);
                break;
            case 10:
                $this->setPhone($value);
                break;
            case 11:
                $this->setFax($value);
                break;
            case 12:
                $this->setUrl($value);
                break;
            case 13:
                $this->setFacebook($value);
                break;
            case 14:
                $this->setTwitter($value);
                break;
            case 15:
                $this->setPinterest($value);
                break;
            case 16:
                $this->setGoogle($value);
                break;
            case 17:
                $this->setYoutube($value);
                break;
            case 18:
                $this->setInstagram($value);
                break;
            case 19:
                $this->setLatitude($value);
                break;
            case 20:
                $this->setLongitude($value);
                break;
            case 21:
                $this->setCreatedAt($value);
                break;
            case 22:
                $this->setUpdatedAt($value);
                break;
            case 23:
                $this->setVersion($value);
                break;
            case 24:
                $this->setVersionCreatedAt($value);
                break;
            case 25:
                $this->setVersionCreatedBy($value);
                break;
            case 26:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerAdminIds($value);
                break;
            case 27:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerAdminVersions($value);
                break;
            case 28:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerProductIds($value);
                break;
            case 29:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerProductVersions($value);
                break;
            case 30:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerOrderIds($value);
                break;
            case 31:
                if (!is_array($value)) {
                    $v = trim(substr($value, 2, -2));
                    $value = $v ? explode(' | ', $v) : array();
                }
                $this->setAmpSellerOrderVersions($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param      array  $arr     An array to populate the object from.
     * @param      string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = AmpSellerVersionTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setRef($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setVisible($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setAddress1($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setAddress2($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setAddress3($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setZipcode($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setCity($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setCountryId($arr[$keys[8]]);
        if (array_key_exists($keys[9], $arr)) $this->setEmail($arr[$keys[9]]);
        if (array_key_exists($keys[10], $arr)) $this->setPhone($arr[$keys[10]]);
        if (array_key_exists($keys[11], $arr)) $this->setFax($arr[$keys[11]]);
        if (array_key_exists($keys[12], $arr)) $this->setUrl($arr[$keys[12]]);
        if (array_key_exists($keys[13], $arr)) $this->setFacebook($arr[$keys[13]]);
        if (array_key_exists($keys[14], $arr)) $this->setTwitter($arr[$keys[14]]);
        if (array_key_exists($keys[15], $arr)) $this->setPinterest($arr[$keys[15]]);
        if (array_key_exists($keys[16], $arr)) $this->setGoogle($arr[$keys[16]]);
        if (array_key_exists($keys[17], $arr)) $this->setYoutube($arr[$keys[17]]);
        if (array_key_exists($keys[18], $arr)) $this->setInstagram($arr[$keys[18]]);
        if (array_key_exists($keys[19], $arr)) $this->setLatitude($arr[$keys[19]]);
        if (array_key_exists($keys[20], $arr)) $this->setLongitude($arr[$keys[20]]);
        if (array_key_exists($keys[21], $arr)) $this->setCreatedAt($arr[$keys[21]]);
        if (array_key_exists($keys[22], $arr)) $this->setUpdatedAt($arr[$keys[22]]);
        if (array_key_exists($keys[23], $arr)) $this->setVersion($arr[$keys[23]]);
        if (array_key_exists($keys[24], $arr)) $this->setVersionCreatedAt($arr[$keys[24]]);
        if (array_key_exists($keys[25], $arr)) $this->setVersionCreatedBy($arr[$keys[25]]);
        if (array_key_exists($keys[26], $arr)) $this->setAmpSellerAdminIds($arr[$keys[26]]);
        if (array_key_exists($keys[27], $arr)) $this->setAmpSellerAdminVersions($arr[$keys[27]]);
        if (array_key_exists($keys[28], $arr)) $this->setAmpSellerProductIds($arr[$keys[28]]);
        if (array_key_exists($keys[29], $arr)) $this->setAmpSellerProductVersions($arr[$keys[29]]);
        if (array_key_exists($keys[30], $arr)) $this->setAmpSellerOrderIds($arr[$keys[30]]);
        if (array_key_exists($keys[31], $arr)) $this->setAmpSellerOrderVersions($arr[$keys[31]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(AmpSellerVersionTableMap::DATABASE_NAME);

        if ($this->isColumnModified(AmpSellerVersionTableMap::ID)) $criteria->add(AmpSellerVersionTableMap::ID, $this->id);
        if ($this->isColumnModified(AmpSellerVersionTableMap::REF)) $criteria->add(AmpSellerVersionTableMap::REF, $this->ref);
        if ($this->isColumnModified(AmpSellerVersionTableMap::VISIBLE)) $criteria->add(AmpSellerVersionTableMap::VISIBLE, $this->visible);
        if ($this->isColumnModified(AmpSellerVersionTableMap::ADDRESS1)) $criteria->add(AmpSellerVersionTableMap::ADDRESS1, $this->address1);
        if ($this->isColumnModified(AmpSellerVersionTableMap::ADDRESS2)) $criteria->add(AmpSellerVersionTableMap::ADDRESS2, $this->address2);
        if ($this->isColumnModified(AmpSellerVersionTableMap::ADDRESS3)) $criteria->add(AmpSellerVersionTableMap::ADDRESS3, $this->address3);
        if ($this->isColumnModified(AmpSellerVersionTableMap::ZIPCODE)) $criteria->add(AmpSellerVersionTableMap::ZIPCODE, $this->zipcode);
        if ($this->isColumnModified(AmpSellerVersionTableMap::CITY)) $criteria->add(AmpSellerVersionTableMap::CITY, $this->city);
        if ($this->isColumnModified(AmpSellerVersionTableMap::COUNTRY_ID)) $criteria->add(AmpSellerVersionTableMap::COUNTRY_ID, $this->country_id);
        if ($this->isColumnModified(AmpSellerVersionTableMap::EMAIL)) $criteria->add(AmpSellerVersionTableMap::EMAIL, $this->email);
        if ($this->isColumnModified(AmpSellerVersionTableMap::PHONE)) $criteria->add(AmpSellerVersionTableMap::PHONE, $this->phone);
        if ($this->isColumnModified(AmpSellerVersionTableMap::FAX)) $criteria->add(AmpSellerVersionTableMap::FAX, $this->fax);
        if ($this->isColumnModified(AmpSellerVersionTableMap::URL)) $criteria->add(AmpSellerVersionTableMap::URL, $this->url);
        if ($this->isColumnModified(AmpSellerVersionTableMap::FACEBOOK)) $criteria->add(AmpSellerVersionTableMap::FACEBOOK, $this->facebook);
        if ($this->isColumnModified(AmpSellerVersionTableMap::TWITTER)) $criteria->add(AmpSellerVersionTableMap::TWITTER, $this->twitter);
        if ($this->isColumnModified(AmpSellerVersionTableMap::PINTEREST)) $criteria->add(AmpSellerVersionTableMap::PINTEREST, $this->pinterest);
        if ($this->isColumnModified(AmpSellerVersionTableMap::GOOGLE)) $criteria->add(AmpSellerVersionTableMap::GOOGLE, $this->google);
        if ($this->isColumnModified(AmpSellerVersionTableMap::YOUTUBE)) $criteria->add(AmpSellerVersionTableMap::YOUTUBE, $this->youtube);
        if ($this->isColumnModified(AmpSellerVersionTableMap::INSTAGRAM)) $criteria->add(AmpSellerVersionTableMap::INSTAGRAM, $this->instagram);
        if ($this->isColumnModified(AmpSellerVersionTableMap::LATITUDE)) $criteria->add(AmpSellerVersionTableMap::LATITUDE, $this->latitude);
        if ($this->isColumnModified(AmpSellerVersionTableMap::LONGITUDE)) $criteria->add(AmpSellerVersionTableMap::LONGITUDE, $this->longitude);
        if ($this->isColumnModified(AmpSellerVersionTableMap::CREATED_AT)) $criteria->add(AmpSellerVersionTableMap::CREATED_AT, $this->created_at);
        if ($this->isColumnModified(AmpSellerVersionTableMap::UPDATED_AT)) $criteria->add(AmpSellerVersionTableMap::UPDATED_AT, $this->updated_at);
        if ($this->isColumnModified(AmpSellerVersionTableMap::VERSION)) $criteria->add(AmpSellerVersionTableMap::VERSION, $this->version);
        if ($this->isColumnModified(AmpSellerVersionTableMap::VERSION_CREATED_AT)) $criteria->add(AmpSellerVersionTableMap::VERSION_CREATED_AT, $this->version_created_at);
        if ($this->isColumnModified(AmpSellerVersionTableMap::VERSION_CREATED_BY)) $criteria->add(AmpSellerVersionTableMap::VERSION_CREATED_BY, $this->version_created_by);
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS)) $criteria->add(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_IDS, $this->amp_seller_admin_ids);
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS)) $criteria->add(AmpSellerVersionTableMap::AMP_SELLER_ADMIN_VERSIONS, $this->amp_seller_admin_versions);
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS)) $criteria->add(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_IDS, $this->amp_seller_product_ids);
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS)) $criteria->add(AmpSellerVersionTableMap::AMP_SELLER_PRODUCT_VERSIONS, $this->amp_seller_product_versions);
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS)) $criteria->add(AmpSellerVersionTableMap::AMP_SELLER_ORDER_IDS, $this->amp_seller_order_ids);
        if ($this->isColumnModified(AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS)) $criteria->add(AmpSellerVersionTableMap::AMP_SELLER_ORDER_VERSIONS, $this->amp_seller_order_versions);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(AmpSellerVersionTableMap::DATABASE_NAME);
        $criteria->add(AmpSellerVersionTableMap::ID, $this->id);
        $criteria->add(AmpSellerVersionTableMap::VERSION, $this->version);

        return $criteria;
    }

    /**
     * Returns the composite primary key for this object.
     * The array elements will be in same order as specified in XML.
     * @return array
     */
    public function getPrimaryKey()
    {
        $pks = array();
        $pks[0] = $this->getId();
        $pks[1] = $this->getVersion();

        return $pks;
    }

    /**
     * Set the [composite] primary key.
     *
     * @param      array $keys The elements of the composite key (order must match the order in XML file).
     * @return void
     */
    public function setPrimaryKey($keys)
    {
        $this->setId($keys[0]);
        $this->setVersion($keys[1]);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return (null === $this->getId()) && (null === $this->getVersion());
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      object $copyObj An object of \ArtabanMarketplace\Model\AmpSellerVersion (or compatible) type.
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param      boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setId($this->getId());
        $copyObj->setRef($this->getRef());
        $copyObj->setVisible($this->getVisible());
        $copyObj->setAddress1($this->getAddress1());
        $copyObj->setAddress2($this->getAddress2());
        $copyObj->setAddress3($this->getAddress3());
        $copyObj->setZipcode($this->getZipcode());
        $copyObj->setCity($this->getCity());
        $copyObj->setCountryId($this->getCountryId());
        $copyObj->setEmail($this->getEmail());
        $copyObj->setPhone($this->getPhone());
        $copyObj->setFax($this->getFax());
        $copyObj->setUrl($this->getUrl());
        $copyObj->setFacebook($this->getFacebook());
        $copyObj->setTwitter($this->getTwitter());
        $copyObj->setPinterest($this->getPinterest());
        $copyObj->setGoogle($this->getGoogle());
        $copyObj->setYoutube($this->getYoutube());
        $copyObj->setInstagram($this->getInstagram());
        $copyObj->setLatitude($this->getLatitude());
        $copyObj->setLongitude($this->getLongitude());
        $copyObj->setCreatedAt($this->getCreatedAt());
        $copyObj->setUpdatedAt($this->getUpdatedAt());
        $copyObj->setVersion($this->getVersion());
        $copyObj->setVersionCreatedAt($this->getVersionCreatedAt());
        $copyObj->setVersionCreatedBy($this->getVersionCreatedBy());
        $copyObj->setAmpSellerAdminIds($this->getAmpSellerAdminIds());
        $copyObj->setAmpSellerAdminVersions($this->getAmpSellerAdminVersions());
        $copyObj->setAmpSellerProductIds($this->getAmpSellerProductIds());
        $copyObj->setAmpSellerProductVersions($this->getAmpSellerProductVersions());
        $copyObj->setAmpSellerOrderIds($this->getAmpSellerOrderIds());
        $copyObj->setAmpSellerOrderVersions($this->getAmpSellerOrderVersions());
        if ($makeNew) {
            $copyObj->setNew(true);
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return                 \ArtabanMarketplace\Model\AmpSellerVersion Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Declares an association between this object and a ChildAmpSeller object.
     *
     * @param                  ChildAmpSeller $v
     * @return                 \ArtabanMarketplace\Model\AmpSellerVersion The current object (for fluent API support)
     * @throws PropelException
     */
    public function setAmpSeller(ChildAmpSeller $v = null)
    {
        if ($v === null) {
            $this->setId(NULL);
        } else {
            $this->setId($v->getId());
        }

        $this->aAmpSeller = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the ChildAmpSeller object, it will not be re-added.
        if ($v !== null) {
            $v->addAmpSellerVersion($this);
        }


        return $this;
    }


    /**
     * Get the associated ChildAmpSeller object
     *
     * @param      ConnectionInterface $con Optional Connection object.
     * @return                 ChildAmpSeller The associated ChildAmpSeller object.
     * @throws PropelException
     */
    public function getAmpSeller(ConnectionInterface $con = null)
    {
        if ($this->aAmpSeller === null && ($this->id !== null)) {
            $this->aAmpSeller = ChildAmpSellerQuery::create()->findPk($this->id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aAmpSeller->addAmpSellerVersions($this);
             */
        }

        return $this->aAmpSeller;
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->ref = null;
        $this->visible = null;
        $this->address1 = null;
        $this->address2 = null;
        $this->address3 = null;
        $this->zipcode = null;
        $this->city = null;
        $this->country_id = null;
        $this->email = null;
        $this->phone = null;
        $this->fax = null;
        $this->url = null;
        $this->facebook = null;
        $this->twitter = null;
        $this->pinterest = null;
        $this->google = null;
        $this->youtube = null;
        $this->instagram = null;
        $this->latitude = null;
        $this->longitude = null;
        $this->created_at = null;
        $this->updated_at = null;
        $this->version = null;
        $this->version_created_at = null;
        $this->version_created_by = null;
        $this->amp_seller_admin_ids = null;
        $this->amp_seller_admin_ids_unserialized = null;
        $this->amp_seller_admin_versions = null;
        $this->amp_seller_admin_versions_unserialized = null;
        $this->amp_seller_product_ids = null;
        $this->amp_seller_product_ids_unserialized = null;
        $this->amp_seller_product_versions = null;
        $this->amp_seller_product_versions_unserialized = null;
        $this->amp_seller_order_ids = null;
        $this->amp_seller_order_ids_unserialized = null;
        $this->amp_seller_order_versions = null;
        $this->amp_seller_order_versions_unserialized = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param      boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep) {
        } // if ($deep)

        $this->aAmpSeller = null;
    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(AmpSellerVersionTableMap::DEFAULT_STRING_FORMAT);
    }

    /**
     * Code to be run before persisting the object
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preSave(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface $con
     */
    public function postSave(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before inserting to database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preInsert(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface $con
     */
    public function postInsert(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before updating the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preUpdate(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface $con
     */
    public function postUpdate(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before deleting the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preDelete(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface $con
     */
    public function postDelete(ConnectionInterface $con = null)
    {

    }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed  $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);

            return $this->importFrom($format, reset($params));
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = isset($params[0]) ? $params[0] : true;

            return $this->exportTo($format, $includeLazyLoadColumns);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
